searchData={"content_type":"text/markdown","items":[{"doc":"A list of relationships that should have all related items archived when this is archived. Note: this is currently not optimized. It simply reads the relationship and archives each one.\n","ref":"dsl-asharchival-resource.html#archive-archive_related","title":"AshArchival.Resource.archive.archive_related","type":"DSL"},{"doc":"A section for configuring how archival is configured for a resource.","ref":"dsl-asharchival-resource.html#archive","title":"AshArchival.Resource.archive","type":"DSL"},{"doc":"An Archival extension for `Ash.Resource`","ref":"AshArchival.html","title":"AshArchival","type":"module"},{"doc":"Configures a resource to be archived instead of destroyed for all destroy actions.\n\nFor more information, see [Archival](/documentation/topics/archival.md)\n\n<!--- ash-hq-hide-start --> <!--- -->","ref":"AshArchival.Resource.html","title":"AshArchival.Resource","type":"module"},{"doc":"#","ref":"AshArchival.Resource.html#module-dsl-documentation","title":"DSL Documentation - AshArchival.Resource","type":"module"},{"doc":"* archive\n\n#","ref":"AshArchival.Resource.html#module-index","title":"Index - AshArchival.Resource","type":"module"},{"doc":"","ref":"AshArchival.Resource.html#module-docs","title":"Docs - AshArchival.Resource","type":"module"},{"doc":"A section for configuring how archival is configured for a resource.\n\n\n\n\n\n\n\n---\n\n* `:archive_related` (list of `t:atom/0`) - A list of relationships that should have all related items archived when this is archived. Note: this is currently not optimized. It simply reads the relationship and archives each one.\n\n\n\n\n\n\n\n<!--- ash-hq-hide-stop--> <!--- -->","ref":"AshArchival.Resource.html#module-archive","title":"archive - AshArchival.Resource","type":"module"},{"doc":"Introspection helpers for `AshArchival.Resource`","ref":"AshArchival.Resource.Info.html","title":"AshArchival.Resource.Info","type":"module"},{"doc":"","ref":"AshArchival.Resource.Info.html#archive_related/1","title":"AshArchival.Resource.Info.archive_related/1","type":"function"},{"doc":"# Archival","ref":"archival.html","title":"Archival","type":"extras"},{"doc":"This extension modifies a resource in the following ways.\n\n1. Adds a private `archived_at` `utc_datetime_usec` attribute.\n2. Adds a base filter to the resource, for `is_nil(archived_at)`\n3. Marks all destroy actions as `soft?`, turning them into updates\n4. Adds a change to all destroy actions that sets `archived_at` to the current timestamp\n5. Adds a change that will iteratively load and destroy anything configured in `d:AshArchival.Resource.archive|archive_related`","ref":"archival.html#extension","title":"Extension - Archival","type":"extras"},{"doc":"#","ref":"archival.html#considerations","title":"Considerations - Archival","type":"extras"},{"doc":"`d:AshArchival.Resource.archive|archive_related` is a simple iterative process. It is performed synchronously, and therefore is not suited for large cardinality relationships. Eventually, when bulk actions are supported, this can be migrated to use that. If you need to archive a very large amount of related things, you will need to write a custom change to handle this.","ref":"archival.html#performance-of-archive-related","title":"Performance of Archive Related - Archival","type":"extras"},{"doc":"See the [Unarchiving guide](/documentation/topics/unarchiving.md) For more.","ref":"archival.html#more","title":"More - Archival","type":"extras"},{"doc":"# Un-archiving\n\nAt the moment, there is no way to unarchive an entry with a simple action on that resource. However, if you define a simple resource that uses the same storage under the hood (e.g same database table), but does *not* use the archival extension. You could then fabricate unarchival with something like this (this is not vetted, it is a pseudo-code example):\n\n```elixir\n# on the archived resource\n# we model it as a create because there is no input record\ncreate :unarchive do\n  manual? true\n  argument :id, :uuid do\n    allow_nil? false\n  end\n\n  change Unarchive\nend\n```\n\nwith an `Unarchive` change like this\n\n```elixir\ndef change(changeset, _, _) do\n  # no data yet, so match on result being `nil`\n  Ash.Changeset.after_action(changeset, fn changeset, nil -> \n    id = Ash.Changeset.get_argument(changeset, :id)\n\n    ResourceWithoutArchival\n    |> Ash.Query.filter(id == ^id)\n    |> Api.read_one()\n    |> case do\n      {:ok, nil} ->\n        # not found error\n      {:ok, found} ->\n        # unarchive\n        found\n        |> Ash.Changeset.for_update(:update, %{archived_at: nil})\n        |> Api.update!()\n\n      {:ok, Api.get!(changeset.resource, id)}\n    end\n  end)\nend\n```","ref":"unarchiving.html","title":"Un-archiving","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshArchival.Resource\n\nConfigures a resource to be archived instead of destroyed for all destroy actions.\n\nFor more information, see [Archival](/documentation/topics/archival.md)\n\n<!--- ash-hq-hide-start --> <!--- -->","ref":"dsl-asharchival-resource.html","title":"DSL: AshArchival.Resource","type":"extras"},{"doc":"#","ref":"dsl-asharchival-resource.html#dsl-documentation","title":"DSL Documentation - DSL: AshArchival.Resource","type":"extras"},{"doc":"* archive\n\n#","ref":"dsl-asharchival-resource.html#index","title":"Index - DSL: AshArchival.Resource","type":"extras"},{"doc":"","ref":"dsl-asharchival-resource.html#docs","title":"Docs - DSL: AshArchival.Resource","type":"extras"},{"doc":"A section for configuring how archival is configured for a resource.\n\n\n\n\n\n\n\n---\n\n* `:archive_related` (list of `t:atom/0`) - A list of relationships that should have all related items archived when this is archived. Note: this is currently not optimized. It simply reads the relationship and archives each one.\n\n\n\n\n\n\n\n<!--- ash-hq-hide-stop--> <!--- -->","ref":"dsl-asharchival-resource.html#archive","title":"archive - DSL: AshArchival.Resource","type":"extras"},{"doc":"A section for configuring how archival is configured for a resource.\n\n\n\n\n\n\n#","ref":"dsl-asharchival-resource.html#archive","title":"archive - DSL: AshArchival.Resource","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`archive_related`](#archive-archive_related){: #archive-archive_related } | `list(atom)` |  | A list of relationships that should have all related items archived when this is archived. Note: this is currently not optimized. It simply reads the relationship and archives each one. |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-asharchival-resource.html#options","title":"Options - DSL: AshArchival.Resource","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,49]}}